package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;

/**
 * Title:        Progetto Laboratorio di Programmazione 2001-2002
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      Universit di Bologna
 * @author Riccardo Solmi
 * @version 1.0
 */

public class AssignmentStatement implements Statement {

	/**
	 * @uml property=id associationEnd={multiplicity={(1 1)}}
	 */
	private final Variable id;

	/**
	 * @uml property=exp associationEnd={multiplicity={(1 1)}}
	 */
	private final Expression exp;

  public AssignmentStatement(Expression id, Expression exp) {
    this.id = (Variable)id;
    this.exp = exp;
  }

  public void prettyPrint(PrintStream out) {
    id.prettyPrint(out);
    out.print(" = ");
    exp.prettyPrint(out);
    out.println(";");
  }

  public void execute() {
    id.setValue(exp.evaluate());
  }
}