package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;

/**
 * Title:        Progetto Laboratorio di Programmazione 2001-2002
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      Universit di Bologna
 * @author Riccardo Solmi
 * @version 1.0
 */

public class EqualsExpression implements Expression {

	/**
	 * @uml property=exp1 associationEnd={multiplicity={(1 1)}}
	 */
	private final Expression exp1;

	/**
	 * @uml property=exp2 associationEnd={multiplicity={(1 1)}}
	 */
	private final Expression exp2;

  public EqualsExpression(Expression exp1, Expression exp2) {
    this.exp1 = exp1;
    this.exp2 = exp2;
  }

  public void prettyPrint(PrintStream out) {
    exp1.prettyPrint(out);
    out.print(" == ");
    exp2.prettyPrint(out);
  }

  public Literal evaluate() {
    return (exp1.evaluate().intValue() == exp2.evaluate().intValue()) ? BooleanLiteral.TRUE : BooleanLiteral.FALSE;
  }
}