package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;

/**
 * Title:        Progetto Laboratorio di Programmazione 2001-2002
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      Universit di Bologna
 * @author Riccardo Solmi
 * @version 1.0
 */

public class NotExpression implements Expression {

	/**
	 * @uml property=exp associationEnd={multiplicity={(1 1)}}
	 */
	private final Expression exp;

  public NotExpression(Expression exp) {
    this.exp = exp;
  }

  public void prettyPrint(PrintStream out) {
    out.print(" ! ");
    exp.prettyPrint(out);
  }

  public Literal evaluate() {
    return (exp.evaluate().booleanValue()) ? BooleanLiteral.FALSE : BooleanLiteral.TRUE;
  }
}