package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;

/**
 * Title:        Progetto Laboratorio di Programmazione 2001-2002
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:      Universit di Bologna
 * @author Riccardo Solmi
 * @version 1.0
 */

public class Variable implements Expression{
  private final String id;

	/**
	 * @uml property=val associationEnd={multiplicity={(0 1)}}
	 */
	private Literal val;

  public Variable(String id) {
    this.id = id;
  }

  public void prettyPrint(PrintStream out) {
    out.print(id);
  }

  public void setValue(Literal val) {
    this.val = val;
  }

  public Literal evaluate() {
  	if (val == null)
  		throw new IllegalStateException("Variabile non inizializzata");

    return val;
  }

  public String toString() {
  	if (val == null)
  		throw new IllegalStateException("Variabile non inizializzata");
	return val.toString();
  }
}