package it.unibo.cs.labp.progetto2001.solmi;

import java.io.*;
import it.unibo.cs.labp.progetto2001.spec.*;


/**
 * Title:        Progetto Laboratorio di Programmazione 2001-2002
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class WhileStatement implements Statement {

	/**
	 * @uml property=exp associationEnd={multiplicity={(1 1)}}
	 */
	private final Expression exp;

	/**
	 * @uml property=stm associationEnd={multiplicity={(1 1)}}
	 */
	private final Statement stm;

  public WhileStatement(Expression exp, Statement stm) {
    this.exp = exp;
    this.stm = stm;
  }

  public void prettyPrint(PrintStream out) {
    out.print("while (");
    exp.prettyPrint(out);
    out.println(") {");
    stm.prettyPrint(out);
    out.println("}");
  }

  public void execute() {
    while (exp.evaluate().booleanValue())
      stm.execute();
  }
}